# Smart hasMany relationship in mongoDB

{% hint style="warning" %}
Please be sure of your agent type and version and pick the right documentation accordingly.
{% endhint %}

{% tabs %}
{% tab title="Node.js" %}
{% hint style="danger" %}
This is the documentation of the `forest-express-sequelize` and `forest-express-mongoose` Node.js agents that will soon reach end-of-support.

`forest-express-sequelize` v9 and `forest-express-mongoose` v9 are replaced by [`@forestadmin/agent`](https://docs.forestadmin.com/developer-guide-agents-nodejs/) v1.

Please check your agent type and version and read on or switch to the right documentation.
{% endhint %}
{% endtab %}

{% tab title="Ruby on Rails" %}
{% hint style="success" %}
This is still the latest Ruby on Rails documentation of the `forest_liana` agent, you’re at the right place, please read on.
{% endhint %}
{% endtab %}

{% tab title="Python" %}
{% hint style="danger" %}
This is the documentation of the `django-forestadmin` Django agent that will soon reach end-of-support.

If you’re using a Django agent, notice that `django-forestadmin` v1 is replaced by [`forestadmin-agent-django`](https://docs.forestadmin.com/developer-guide-agents-python) v1.

If you’re using a Flask agent, go to the [`forestadmin-agent-flask`](https://docs.forestadmin.com/developer-guide-agents-python) v1 documentation.

Please check your agent type and version and read on or switch to the right documentation.
{% endhint %}
{% endtab %}

{% tab title="PHP" %}
{% hint style="danger" %}
This is the documentation of the `forestadmin/laravel-forestadmin` Laravel agent that will soon reach end-of-support.

If you’re using a Laravel agent, notice that `forestadmin/laravel-forestadmin` v1 is replaced by [`forestadmin/laravel-forestadmin`](https://docs.forestadmin.com/developer-guide-agents-php) v3.

If you’re using a Symfony agent, go to the [`forestadmin/symfony-forestadmin`](https://docs.forestadmin.com/developer-guide-agents-php) v1 documentation.

Please check your agent type and version and read on or switch to the right documentation.
{% endhint %}
{% endtab %}
{% endtabs %}

## Smart hasMany relationship in mongoDB

**Context**: As a user I want to display records that have a belongsTo relationship to another record as related data of this record.

Parent collection: `user`

Child collection: `visualization`

### Models definition

`models/user.js`

```jsx
// This model was generated by Lumber. However, you remain in control of your models.
// Learn how here: <https://docs.forestadmin.com/documentation/v/v6/reference-guide/models/enrich-your-models>
const mongoose = require('mongoose');

// This section contains the properties of your model, mapped to your collection's properties.
// Learn more here: <https://docs.forestadmin.com/documentation/v/v6/reference-guide/models/enrich-your-models#declaring-a-new-field-in-a-model>
const schema = mongoose.Schema(
  {
    avatar_link: String,
    client: { type: mongoose.Schema.Types.ObjectId, ref: 'client' },
    date_added: Date,
    email: String,
    first_name: String,
    last_name: String,
    user_type: String,
  },
  {
    timestamps: false,
  }
);

module.exports = mongoose.model('user', schema, 'user');
```

`models/visualization.js`

```jsx
// This model was generated by Lumber. However, you remain in control of your models.
// Learn how here: <https://docs.forestadmin.com/documentation/v/v6/reference-guide/models/enrich-your-models>
const mongoose = require('mongoose');

// This section contains the properties of your model, mapped to your collection's properties.
// Learn more here: <https://docs.forestadmin.com/documentation/v/v6/reference-guide/models/enrich-your-models#declaring-a-new-field-in-a-model>
const schema = mongoose.Schema(
  {
    description: String,
    name: String,
    user: { type: mongoose.Schema.Types.ObjectId, ref: 'user' },
    visualization_type: String,
  },
  {
    timestamps: false,
  }
);

module.exports = mongoose.model('visualization', schema, 'visualization');
```

### Declaration of the relationship

As the relationship that is not present in your database structure, declare it at the level of the forest folder.

`forest/user.js`

```jsx
const { collection } = require('forest-express-mongoose');
const { customFieldsStyles } = require('../style/fields-style.js');

// This file allows you to add to your Forest UI:
// - Smart actions: <https://docs.forestadmin.com/documentation/reference-guide/actions/create-and-manage-smart-actions>
// - Smart fields: <https://docs.forestadmin.com/documentation/reference-guide/fields/create-and-manage-smart-fields>
// - Smart relationships: <https://docs.forestadmin.com/documentation/reference-guide/relationships/create-a-smart-relationship>
// - Smart segments: <https://docs.forestadmin.com/documentation/reference-guide/segments/smart-segments>
collection('user', {
  actions: [],
  fields: [
    {
      field: 'visualizations',
      type: ['String'],
      reference: 'visualization._id',
    },
  ],
  segments: [],
});
```

### Implementation of the get route for the relationship

The route to get the related visualizations when you are on a user page needs to be implemented in the routes folder.

`routes/user.js`

```javascript
const express = require('express');
const { PermissionMiddlewareCreator, RecordSerializer } = require('forest-express-mongoose');
const mongoose = require('mongoose');
const { visualization } = require('../models');

const router = express.Router();
const permissionMiddlewareCreator = new PermissionMiddlewareCreator('user');

...

router.get('/user/:recordId/relationships/visualizations', permissionMiddlewareCreator.details(), async (req, res, next) => {
  const limit = parseInt(req.query.page.size) || 10;
  const offset = (parseInt(req.query.page.number) - 1) * limit;
  const userObjectId = mongoose.Types.ObjectId(req.params.recordId);
  const visualizationSerializer = new RecordSerializer({ modelName: 'visualization' });
  const count = await visualization.countDocuments({ user: userObjectId });
  const data = await visualization.find({ user: userObjectId }, null, { skip: offset, limit });
  const dataSerialized = await visualizationSerializer.serialize(data, { count });
  res.send(dataSerialized);
});

module.exports = router;j
```


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.forestadmin.com/documentation/reference-guide/models/relationships/smart-relationship-examples/smart-hasmany-relationship-in-mongodb.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
